<?php
namespace Planejamento\Repositories;

class Confirmarefe extends \Doctrine\ORM\EntityRepository
{
    public function getAlteracoesCardapio(
        $nrorg, $cdfilial, $cdservfili,
        $nrcardapio, $dtcardapio, $idqtdeaprovada
    )
    {
        $sql
            = "SELECT CO.*
                FROM CONFIRMAREFE CO
                INNER JOIN
                  (SELECT NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO,
                    MAX(NRCONFIRMAREFE) AS NRCONFIRMAREFE
                  FROM CONFIRMAREFE
                  WHERE NRORG          = :P_NRORG
                  AND CDFILIAL         = :P_CDFILIAL
                  AND CDSERVFILI       = :P_CDSERVFILI
                  AND NRCARDAPIO       = :P_NRCARDAPIO
                  AND DTCARDAPIO       = :P_DTCARDAPIO
                  AND CDCLIENTE       IS NULL
                  AND CDDESTFILI      IS NULL
                  AND CDTURNO         IS NULL
                  AND IDQTDEAPROVADA   = :P_IDQTDEAPROVADA
                  GROUP BY NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO
                  ) C
                ON C.NRORG           = CO.NRORG
                AND C.NRCONFIRMAREFE = CO.NRCONFIRMAREFE
                ORDER BY CO.NRCONFIRMAREFE,
                          CO.CDFILIAL,
                          CO.CDSERVFILI,
                          CO.NRCARDAPIO,
                          CO.DTCARDAPIO";

        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDFILIAL' => $cdfilial,
            'P_CDSERVFILI' => $cdservfili,
            'P_NRCARDAPIO' => $nrcardapio,
            'P_DTCARDAPIO' => $dtcardapio,
            'P_IDQTDEAPROVADA' => $idqtdeaprovada
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return count($result) > 0 ? $result : array();
    }

    public function getAlteracoesTurnos(
        $nrorg, $cdfilial, $cdservfili,
        $nrcardapio, $dtcardapio, $idqtdeaprovada
    )
    {
        $sql
            = "SELECT CO.*
                FROM CONFIRMAREFE CO
                INNER JOIN
                  (SELECT NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO,
                    CDTURNO,
                    MAX(NRCONFIRMAREFE) AS NRCONFIRMAREFE
                  FROM CONFIRMAREFE
                  WHERE NRORG          = :P_NRORG
                  AND CDFILIAL         = :P_CDFILIAL
                  AND CDSERVFILI       = :P_CDSERVFILI
                  AND NRCARDAPIO       = :P_NRCARDAPIO
                  AND DTCARDAPIO       = :P_DTCARDAPIO
                  AND CDCLIENTE       IS NULL
                  AND CDDESTFILI      IS NULL
                  AND CDTURNO         IS NOT NULL
                  AND IDQTDEAPROVADA   = :P_IDQTDEAPROVADA
                  GROUP BY NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO,
                    CDTURNO
                  ) C
                ON C.NRORG           = CO.NRORG
                AND C.NRCONFIRMAREFE = CO.NRCONFIRMAREFE
                ORDER BY CO.NRCONFIRMAREFE,
                          CO.CDFILIAL,
                          CO.CDSERVFILI,
                          CO.NRCARDAPIO,
                          CO.DTCARDAPIO";

        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDFILIAL' => $cdfilial,
            'P_CDSERVFILI' => $cdservfili,
            'P_NRCARDAPIO' => $nrcardapio,
            'P_DTCARDAPIO' => $dtcardapio,
            'P_IDQTDEAPROVADA' => $idqtdeaprovada
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return count($result) > 0 ? $result : array();
    }

    public function getAlteracoesPontosEntrega(
        $nrorg, $cdfilial, $cdservfili,
        $nrcardapio, $dtcardapio, $idqtdeaprovada
    )
    {
        $sql
            = "SELECT CO.*
                FROM CONFIRMAREFE CO
                INNER JOIN
                  (SELECT NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO,
                    CDCLIENTE,
                    CDDESTFILI,
                    MAX(NRCONFIRMAREFE) AS NRCONFIRMAREFE
                  FROM CONFIRMAREFE
                  WHERE NRORG          = :P_NRORG
                  AND CDFILIAL         = :P_CDFILIAL
                  AND CDSERVFILI       = :P_CDSERVFILI
                  AND NRCARDAPIO       = :P_NRCARDAPIO
                  AND DTCARDAPIO       = :P_DTCARDAPIO
                  AND CDCLIENTE       IS NOT NULL
                  AND CDDESTFILI      IS NOT NULL
                  AND CDTURNO         IS NULL
                  AND IDQTDEAPROVADA   = :P_IDQTDEAPROVADA
                  GROUP BY NRORG,
                    CDFILIAL,
                    CDSERVFILI,
                    NRCARDAPIO,
                    DTCARDAPIO,
                    CDCLIENTE,
                    CDDESTFILI
                  ) C
                ON C.NRORG           = CO.NRORG
                AND C.NRCONFIRMAREFE = CO.NRCONFIRMAREFE
                ORDER BY CO.NRCONFIRMAREFE,
                          CO.CDFILIAL,
                          CO.CDSERVFILI,
                          CO.NRCARDAPIO,
                          CO.DTCARDAPIO";

        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDFILIAL' => $cdfilial,
            'P_CDSERVFILI' => $cdservfili,
            'P_NRCARDAPIO' => $nrcardapio,
            'P_DTCARDAPIO' => $dtcardapio,
            'P_IDQTDEAPROVADA' => $idqtdeaprovada
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return count($result) > 0 ? $result : array();
    }
}