<?php

require_once 'base/TipohierarqorgEntityBase.php';

/**
 * TipohierarqorgEntity.
 *
 * @package Entity
 * @author  alessandrobartels
 *
 */
class TipohierarqorgEntity extends TipohierarqorgEntityBase
{


    /**
     * Retorna entity Tipo hierarquia.
     *
     * @param integer $nr_org             Numero da organizacao.
     * @param integer $nr_tipo_hierarquia Numero do tipo de hierarquia.
     *
     * @return TipohierarqorgEntity
     */
    public function retornaTipoHierarquia($nrOrgPadrao, $nr_org, $nr_tipo_hierarquia){
        $resultado = Tipohierarqorg::retornaTipoHierarquia($nrOrgPadrao, $nr_org, $nr_tipo_hierarquia);
        return $resultado;
    }


    public function carregaTipoHierarquia($nrOrgPadrao, $nrOrg, $nrTipoHierarquia){
        $resultado = $this->retornaTipoHierarquia($nrOrgPadrao, $nrOrg, $nrTipoHierarquia);
        //foreach ($resultado as $item){
        $this->addItem($resultado);
        //}
    }

    /**
     * @param $nrorg
     * @param $nrestruturamrel
     * @param $nrestruturamsup
     * @return null
     * @throws Exception
     */
    public static function getTipoHierarquiaPorEstruturasRelacionadas($nrorg, $nrestruturamrel, $nrestruturamsup)
    {
        /** @var $estruturaRelacionada EstruturamEntity */
        $estruturaRelacionada = EstruturamEntity::getEntityByWhere(
            'NRORG = ? AND NRESTRUTURAM = ?', array($nrorg, $nrestruturamrel)
        );
        if (!$estruturaRelacionada) {
            throw new Exception('Estrutura relacionada inválida!');
        }
        /** @var $estruturaSuperior EstruturamEntity */
        $estruturaSuperior = EstruturamEntity::getEntityByWhere(
            'NRORG = ? AND NRESTRUTURAM = ?', array($nrorg, $nrestruturamsup)
        );
        if (!$estruturaSuperior) {
            throw new Exception('Estrutura superior inválida!');
        }
        /** @var $tipoHierarqorg TipohierarqorgEntity */
        $tipoHierarqorg = TipohierarqorgEntity::getEntityByWhere(
            '(NRORG = 0 OR NRORG = ?) AND NRTIPOESTRUTREL = ? AND NRTIPOESTRUTSUP = ?',
            array($nrorg, $estruturaRelacionada->getNrtipoestrutura(), $estruturaSuperior->getNrtipoestrutura())
        );
        $nrtipoHierarqorg = $tipoHierarqorg->getNrtipohierarqorg();
        return $nrtipoHierarqorg;
    }

}